define(["ext"] , function(require){

	var Router=function(){
	    var WinUrl = api.wgtRootDir +"/modules/win-frame.html";//带头部导航的母版窗口
	    var NoHeaderWinUrl=api.wgtRootDir +"/modules/win-frame-noheader.html";//不带头部导航的母版窗口
	  
		var RouterModel = {
			Main: {
			    AppID:api.appId, //应用ID
			    WinName:'Main-Win', //Win的名称
			    WinUrl:api.wgtRootDir + "/modules/main/main-con.html",  //Win的路径地址
				FrameName: 'Main', //Win中开启Frame的名称
				FrameUrl: api.wgtRootDir + "/modules/main/main.html", //Win中开启Frame的路径地址
				BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
				Title: '联诚App开发环境', //窗口标题
				slidBackEnabled:false,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
				ShowProgress:false, //是否显示加载进度条
				Bounces:true, //Frame是否开启弹动效果
				ScaleEnabled:false, //Frame中的页面是否可以缩放
				Reload:false //再次切换到此窗口时，是否重新加载Frame
			},
            LoadingModule:{
                AppID:api.appId, //应用ID
                WinName:'LoadingModule-Win', //Win的名称
                WinUrl:api.wgtRootDir + "/modules/main/loading-module.html",  //Win的路径地址
                FrameName: 'LoadingModule', //Win中开启Frame的名称
                FrameUrl: api.wgtRootDir + "/modules/main/loading-module.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '加载模块', //窗口标题
                slidBackEnabled:false,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:false, //是否显示加载进度条
                Bounces:false, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false //再次切换到此窗口时，是否重新加载Frame
            },
			PhoneInfo:{
			   AppID:api.appId, //应用ID
			    WinName:'PhoneInfo-Win', //Win的名称
			    WinUrl:WinUrl,  //Win的路径地址
				FrameName: 'PhoneInfo', //Win中开启Frame的名称
				FrameUrl: api.wgtRootDir + "/modules/main/phone-info.html", //Win中开启Frame的路径地址
				BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
				Title: '设备信息', //窗口标题
				slidBackEnabled:false,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
				ShowProgress:false, //是否显示加载进度条
				Bounces:true, //Frame是否开启弹动效果
				ScaleEnabled:false, //Frame中的页面是否可以缩放
				Reload:false //再次切换到此窗口时，是否重新加载Frame
			}
		}
		
		
		
		var OpenMainWin = function() {
            RouterModel.Main.WinAnimation={
                type : 'fade',
                duration : 300
            }
			Ext.OpenWinByModel(RouterModel.Main);
		}

		var OpenMainFrame = function() {
            RouterModel.Main.FrameAnimation={
                type : 'fade',
                duration : 300
            }
            Ext.OpenFrameByModel(RouterModel.Main);
		}

        var OpenLoadingModuleWin = function() {
            RouterModel.LoadingModule.WinAnimation={
                type : 'fade',
                duration : 300
            }
            Ext.OpenWinByModel(RouterModel.LoadingModule);
        }

        var OpenPhoneInfo = function() {
            RouterModel.PhoneInfo.WinAnimation={
                type : 'fade',
                duration : 300
            }
            Ext.OpenWinByModel(RouterModel.PhoneInfo);
		} 
		
		return {
			RouterModel: RouterModel,
			OpenMainWin:OpenMainWin,
			OpenMainFrame:OpenMainFrame,
			OpenPhoneInfo:OpenPhoneInfo,
            OpenLoadingModuleWin:OpenLoadingModuleWin
		}
	}
	return Router;

})