define(function() {

    var Ext = {
        CheckLogin: function() {
            var curUserInfo = AppFrame.CurUserInfo.Get();
            if (curUserInfo.UserId == 0) {
                return false;
            } else {
                return true;
            }
        },

        FixMuiNavigateRight: function() {
            var isAndroid = (/android/gi).test(navigator.appVersion);
            if (!isAndroid) {
                $(".mui-table-view").find(".mui-navigate-right").addClass("mui-navigate-right-fix");
            }
        },

        //--------------------------------------------------------

        BindPush: function(userId, CB) {
            var push = api.require('push');
            push.bind({
                userName: '',
                userId: userId
            }, function(ret, err) {
                if (CB) {
                    CB(ret, err);
                }
            });
        },

        AddPushGroup: function(GroupName, CB) {
            // var IsReceivePush = $api.getStorage(StorageKey.IsReceivePush) ? $api.getStorage(StorageKey.IsReceivePush) : 0;
            //  if (IsReceivePush == 0) return;
            var push = api.require('push');
            push.joinGroup({
                groupName: GroupName
            }, function(ret, err) {
                if (CB) {
                    CB(ret, err);
                }
            });
        },
        LeavePushGroup: function(GroupName, CB) {
            var push = api.require('push');
            push.leaveGroup({
                groupName: GroupName
            }, function(ret, err) {
                if (CB) {
                    CB(ret, err);
                }
            });
        },
        PushSetListener: function(CB) {
            var push = api.require('push');
            push.setListener(function(ret, err) {

                if (CB) {
                    CB(ret, err);
                }
            });
        },
        PushRemoveListener: function(CB) {
            var push = api.require('push');
            push.removeListener();
        },
        //------------------------------------------
        //搞定IOS的头部
        FixIOSHead: function() {
            var header = $api.byId('header');
            $api.fixStatusBar(header);
        },


        Toast: function(msg, location) {
            api.toast({
                msg: msg,
                duration: 3000,
                location: location
            })
        },

        //下拉刷新
        BindPullFlash: function(CallBack) {
            api.setCustomRefreshHeaderInfo({
                bgColor: AppFrame.Data.PullRefresh.BgColor,
                isScale: false,
                image: {
                    pull: AppFrame.Data.PullRefresh.Pull,
                    load: AppFrame.Data.PullRefresh.Load
                }
            }, function() {
                //下拉刷新被触发，自动进入加载状态，使用 api.refreshHeaderLoadDone() 手动结束加载中状态
                //下拉刷新被触发，使用 api.refreshHeaderLoadDone() 结束加载中状态  
                if (CallBack) CallBack();
                setTimeout(function() {
                    api.refreshHeaderLoadDone();
                }, 10000);
            });
        },


        //跨Frame执行Script方法
        ExecScript: function(TargetWin, TargetFrame, ScriptMethodName) {
            //alert(TargetFrame+ "  " + ScriptMethodName);
            var option = {};
            if (TargetWin != "")
                option.name = TargetWin;
            if (TargetFrame != "")
                option.frameName = TargetFrame;
            if (ScriptMethodName != "")
                option.script = ScriptMethodName;
            api.execScript(option);
        },

        getRoot: function() {
            var strFullPath = window.document.location.href;
            var strPath = window.document.location.pathname;
            var pos = strFullPath.indexOf(strPath);
            var prePath = strFullPath.substring(0, pos);
            var postPath = strPath.substring(0, strPath.substr(1).indexOf('/') + 1);
            return (prePath + postPath);
        },

        OpenWidget: function(id, params, animation, callback) {
            //			var option={
            //				id : id
            //				,animation : {
            //					type : 'push',
            //					subType : 'from_right',
            //					duration : 300
            //				}
            //			};
            //			if(animation){
            //		    	option.animation=animation;
            //			}
            //  		api.openWidget(option, function(ret, err) {
            //				if (callback)
            //					callback(ret, err);
            //			});

            var option = {
                name: id + "-widget",
                url: "fs://wgt/" + id + "/index.html",
                bounces: false,
                opaque: false,
                //bgColor: '#353A40',
                pageParam: params,
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
                slidBackEnabled: true,
                slidBackType: 'edge',
                showProgress: false,
                scrollToTop: true,
                animation: {
                    type: "movein", //动画类型（详见动画类型常量）
                    subType: "from_right", //动画子类型（详见动画子类型常量）
                    duration: 300 //动画过渡时间，默认300毫秒
                }
            };
            if (animation) {
                option.animation = animation;
            }

            api.openWin(option);
        },

        CloseWidget: function(id, animation) {
            //			var option = {
            //				animation : {
            //					type : 'push',
            //					subType : 'from_left',
            //					duration : 300
            //				}
            //			}
            //			if(id){
            //			   option.id=id;
            //			}
            //			if(animation){
            //			  option.animation=animation;
            //			}
            //			api.closeWidget(option);
            var name = "";
            if (id) {
                name = id + "-widget";
            }
            var option = {
                name: name,
                animation: {
                    type: "reveal",
                    subType: "from_left",
                    duration: 350
                }
            }
            if (animation) {
                option.animation = animation;
            }

            api.closeWin(option);
        },

        OpenWin: function(name, url, slidBackEnabled, params, animation) {
            var option = {
                name: name,
                url: url,
                pageParam: params,
                delay: 0,
                bounces: false,
                opaque: false,
                //bgColor: '#353A40',
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
                slidBackEnabled: slidBackEnabled ,
                slidBackType: 'edge',
                showProgress: false,
                scrollToTop: true,
                animation: {
                    type: "movein", //动画类型（详见动画类型常量）
                    subType: "from_right", //动画子类型（详见动画子类型常量）
                    duration: 300 //动画过渡时间，默认300毫秒
                }
            };
            if (animation) {
                option.animation = animation;
            }

            api.openWin(option);
        },

        OpenWinByModel: function(model) {
            if (!model.WinAnimation) {
                model.WinAnimation = {
                    type: "movein", //动画类型（详见动画类型常量）
                    subType: "from_right", //动画子类型（详见动画子类型常量）
                    duration: 300 //动画过渡时间，默认300毫秒
                };
            }
            var option = {
                name: model.WinName,
                url:  model.WinUrl,
                pageParam: model,
                delay: model.delay?model.delay:0,
                bounces: model.WinBounces?model.WinBounces:false,
                opaque: model.opaque?model.opaque:false,
                //bgColor: '#353A40',
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
                slidBackEnabled:  model.slidBackEnabled ,
                slidBackType: 'edge',
                showProgress: model.showProgress?model.showProgress: false,
                scrollToTop: true,
                animation: model.WinAnimation,
                reload:model.reload?model.reload:false
            };


            api.openWin(option);

        },

        CloseWin: function(WinName, animation) {
            var option = {
                name: WinName,
                animation: {
                    type: "reveal",
                    subType: "from_left",
                    duration: 300
                }
            }
            if (animation) {
                option.animation = animation;
            }

            api.closeWin(option);
        },

        //打开目标Url到Frame中
        OpenFrame: function(name, url, params, bgColor, showProgress, bounces, scaleEnabled, reload, animation, rect) {

            var main = $api.byId('main');
            var mainPos = $api.offset(main);


            var Params = {};
            if (typeof(params) === "string") {
                Params = $api.strToJson(Tools.base64decode(params));
            } else {
                Params = params;
            }

            var option = {
                name: name,
                url: url,
                bounces: bounces != null ? bounces : true,
                bgColor: bgColor ? bgColor : '#fff',
                showProgress: showProgress != null ? showProgress : false,
                pageParam: Params,
                reload: reload ? reload : false,
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
                scaleEnabled: scaleEnabled != null ? scaleEnabled : false,

                animation: {
                    type: "fade",
                    //subType : "from_left",
                    duration: 300
                },
                rect: {
                    x: mainPos.l,
                    y: mainPos.t,
                    // w: mainPos.w,
                    h: mainPos.h
                }

            };
            if (animation) {
                option.animation = animation;
            } else {
                if (api.systemType == "ios") {
                    option.animation = {
                        type: 'none',
                    };
                }
            }
            if (rect) {
                option.rect = rect;
            }

            api.openFrame(option);
        },



        OpenFrameByModel: function(Model) {
            var main = $api.byId('main');
            var mainPos = $api.offset(main);


            var option = {
                name: Model.FrameName,
                url: Model.FrameUrl,
                bounces: Model.Bounces?Model.Bounces:true,
                bgColor: Model.BgColor ? Model.BgColor : '#fff',
                showProgress: Model.ShowProgress != null ? Model.ShowProgress : false,
                pageParam: Model,
                reload: Model.Reload ? Model.Reload : false,
                vScrollBarEnabled: false,
                hScrollBarEnabled: false,
                scaleEnabled: Model.ScaleEnabled != null ? Model.ScaleEnabled : false,

                animation: {
                    type: "fade",
                    //subType : "from_left",
                    duration: 300
                },
                rect: {
                    x: mainPos.l,
                    y: mainPos.t,
                    // w: mainPos.w,
                    h: mainPos.h
                }

            };
            if (Model.FrameAnimation) {
                option.animation = Model.FrameAnimation;
            } else {
                if (api.systemType == "ios") {
                    option.animation = {
                        type: 'none',
                    };
                }
            }
            if (Model.Rect) {
                option.rect = Model.Rect;
            }

            api.openFrame(option);


        },

        ///使用代理在目标Frame中开启新的frame
        OpenFrame_Proxy: function(TargetWin, TargetFrame, name, url, params, bgColor, showProgress, bounces, scaleEnabled, reload) {
            var PageParamStr = Func.base64encode(JSON.stringify(params));
            bgColor = bgColor ? bgColor : "#ffffff";
            showProgress = showProgress != null ? showProgress : false;
            bounces = bounces != null ? bounces : true;
            scaleEnabled:
                scaleEnabled != null ? scaleEnabled : false, reload = reload != null ? reload : false;
            // App.ExecScript(TargetWin, TargetFrame, 'App.OpenFrame("' + name + '","' + url + '","'+params+'","' + bgColor + '",' + showProgress + ',' + bounces + ',' + scaleEnabled + ',' + reload + ')');
            Ext.ExecScript(TargetWin, TargetFrame, 'AppFrame.Ext.OpenFrame("' + name + '","' + url + '","' + PageParamStr + '","' + bgColor + '",' + showProgress + ',' + bounces + ',' + scaleEnabled + ',' + reload + ')');
        },
        //关闭Frame
        CloseFrame: function(name) {
            if (!name) name = api.frameName;
            api.closeFrame({
                name: name
            });
        },
        //使用代理关闭目标Frame中的Frame
        CloseFrame_Proxy: function(TargetWin, TargetFrame, name) {
            Ext.ExecScript(TargetWin, TargetFrame, 'AppFrame.Ext.CloseFrame("' + name + '")');
        },

        //隐藏Frame
        HiddenFrame: function(name) {
            api.setFrameAttr({
                name: name,
                hidden: true
            });
        },
        //使用代理隐藏目标Frame中的Frame
        HiddenFrame_Proxy: function(TargetWin, TargetFrame, name) {
            Ext.ExecScript(TargetWin, TargetFrame, 'AppFrame.Ext.HiddenFrame("' + name + '")');
        },

        OpenWin_NoHeader: function(Router) {
            OpenWin(Router.FrameName + "-Win", AppFrame.Dir.GetRootDir() + '/modules/win-frame-noheader.html', Router.slidBackEnabled, Router);
        },
        OpenWin_Header: function(Router) {
            OpenWin(Router.FrameName + "-Win", AppFrame.Dir.GetRootDir() + '/modules/win-frame.html', Router.slidBackEnabled, Router);
        },

        //显示Frame
        ShowFrame: function(name) {
            api.setFrameAttr({
                name: name,
                hidden: false
            });
        },
        //使用代理显示目标Frame中的Frame
        ShowFrame_Proxy: function(TargetWin, TargetFrame, name) {
            Ext.ExecScript(TargetWin, TargetFrame, 'AppFrame.Ext.ShowFrame("' + name + '")');
        },

        //------------------------------------------------
        ShowProgress: function(title, text, modal) {
            api.showProgress({
                style: 'default',
                animationType: 'fade',
                title: title,
                text: text,
                modal: modal
            });

        },
        HideProgress: function() {
            api.hideProgress();
        },
        //-------------------------------------------------

        OpenLoadingLabel: function(fixedOn, CB) {
            var frameHeight = api.frameHeight;
            var loadingLabel = api.require('loadingLabel');
            loadingLabel.open({
                fixedOn: fixedOn,
                bgColor: '#555',
                lightColor: '#FFCC33',
                centerX: '',
                centerY: 200
            }, function(ret) {
                if (CB) {
                    CB(ret);
                }
            });
        },

        CloseLoadingLabel: function(id) {
            var loadingLabel = api.require('loadingLabel');
            loadingLabel.close({
                id: id
            });
        },
        //------------------------------------------------------
        //拨打电话
        Call: function(PhoneNo) {
            api.call({
                type: 'tel_prompt',
                number: PhoneNo
            });
        },

        //开启外部页面
        OpenUrl: function(Title, Frame_bounces, Url) {
            if (Url.indexOf("undefined") > -1)
                return;
            var Params = {
                FrameName: 'WebView',
                FrameUrl: Url,
                Title: Title,
                Frame_bounces: Frame_bounces,
                Frame_showProgress: true
            };
            Ext.OpenWin('WebView_Win', api.wgtRootDir + '/modules/win-frame.html', Params);
        }
    }

    window.Ext = Ext;

    return Ext;
})