define( function(){
	
	/**
	 * 当前登录的用户信息
	 */
	var CurUserInfo = function() {
		var KeyName = "CurUserInfo";
		var prefsKeyName="Prefs";//用户偏好
		var Get = function() {
			var _CurUserInfo=null;
            var __CurUserInfo = api.getPrefs({
                sync: true,
                key: KeyName
            });

			if (!__CurUserInfo || __CurUserInfo=="") {
				_CurUserInfo = {
					UserId: 0,
					UserEmail: "",
					UserRealName: "",
					UserMobile:"",
					HeaderImg: "",
					ClientID:"",
					vk: ""
				};
			}else{
                _CurUserInfo=JSON.parse(__CurUserInfo);
				if(_CurUserInfo.UserRealName=="") _CurUserInfo.UserRealName=_CurUserInfo.UserMobile;
			}

			return _CurUserInfo;
		};

		var Set = function(Model) {

            api.setPrefs({
                key: KeyName,
                value: JSON.stringify(Model)
            });
		};

		var Clear = function() {
            api.removePrefs({
                key: KeyName
            });
		}
		
		var Prefs={};
		Prefs.Get=function(){
			var _Prefs=null;
            var __Prefs = api.getPrefs({
                sync: true,
                key: prefsKeyName
            });
			var _Prefs = $api.getStorage(prefsKeyName);
			if(!__Prefs || __Prefs==""){
				_Prefs={};
			}else{
                _Prefs=JSON.parse(__Prefs);
			}
			return _Prefs;
		}
		
		Prefs.Set=function(Model){
            api.setPrefs({
                key: prefsKeyName,
                value: JSON.stringify(Model)
            });
		}

		return {
			Get: Get,
			Set: Set,
			Clear: Clear,
			Prefs:Prefs
		}
	}();
	
	window.CurUserInfo=CurUserInfo;

    return CurUserInfo;
})
