require.config({
    //baseUrl:'./',

    paths: { //paths中定义了脚本的逻辑，是相对于js-config.js 文件的，只要这里的路径地址是对的，以后都不需要考虑脚本的文件地址，直接引用

        'af': 'libs/appframework.min', //类此与jquery的简化框架
        'jquery': 'libs/jquery-1.11.0.min', //jquery
        'mui': 'libs/mui.min', //mui框架
        'then': 'libs/then.min', //thenJs 链式书写强逻辑时必须用到的工具
        'dot': 'libs/doT.min', //一个模板工具
        'echarts':'libs/echarts.min',
        'moment':'libs/moment.min',//时间处理类
        'app-frame': 'frame/app-frame.min', //AppFrame 主入口内
        'user-info': 'frame/user-info.min', //当前登录用户信息
        'ext': 'frame/ext.min', //apicloud 的 封装 和 扩展
        'tools': 'frame/tools.min', //工具类
        //'style' : 'frame/style', //虚拟文件，目的是 通过依赖，异步加载全局样式 ， 因为体验问题，这个暂时没用到
        'api': 'libs/api', //apicloud 的 api.js
        'frame-data': 'frame/frame-data.min', //框架静态数据
        'bMap': 'frame/bMap.min',
        'interface':'../frame-interface',
        //----------------以上为框架用到的， 以下为根据具体需求 增加的 比如 每个模块的 Router -----------
        'main-router': '../modules/main/script/router',
        'setting-router': '../modules/setting/script/router',
        'user-router': '../modules/user/script/router'
    },
    map: { //这里定义了，无论加载哪个模块，都必须先加载的js文件
        '*': {
            //'css' : 'libs/css.min',  //require对css文件的支持 就靠这个css.js

        }
    },
    shim: { //依赖 设置 在这里
        //'style' : ['css!../css/app', 'css!../css/font-awesome.min', 'css!../css/frozen.css'],
        'app-frame': ['api'],
        'user-info': ['api'],
        'ext': ['api']
    }
});
