﻿define(function(require) {

    var InterFace = function(AppInfo) {
        //返回Main的路由
        var Main = function(cb) {
            require([AppInfo.BaseUrl + "/modules/main/script/router.js"], function(router) {
                if (cb) cb(router(AppInfo));
            })
        }


        //供从个人中心调用app-info.js中配置的个人中心项目 测试用
        var OpenPhoneInfo = function() {
            Main(function(Router) {
                Router.OpenPhoneInfo();
            })
        }

		/**
         * 百度webapi获取圆形区域内的指定类别poi
         */
        var getRadiuPoiListByType=function(fliter,CB){
        	var url = AppInfo.CustomItems.Url.GetBaiDuWebApiPoilList;
        	AppFrame.Http.Get(url+fliter,function(ret,err){
        		if(CB)CB(ret,err);
        	})
        }
        
       
        

        /**
         * 获取交通事件
         */
        var GetTafficState = function(CB) {
            var url = AppInfo.CustomItems.Url.GetTafficState;
            var PostData = {};
            AppFrame.Http.Post(url, PostData, function(ret, err) {
                if (CB) CB(ret, err);
            })
        }

        /**
         * 获取某路公交GPS数据
         * busname ='047路'；
         */
        var GetBusGpsInfo = function(busName,CB) {        	
            var url = AppInfo.CustomItems.Url.GetBusGps;           
            if(busName && busName.length==3){            	
            	busName = '0'+busName;            	
            }
            if(busName && busName.length==2){            	
            	busName = '00'+busName;            	
            }
            url = url+"?busname="+busName; 
            console.log('busname:'+busName);    
            AppFrame.Http.Get(url,  function(ret, err) {
                if (CB) CB(ret, err);
            })
        }


        return {
            Main: Main,
            GetTafficState: GetTafficState,
            getRadiuPoiListByType:getRadiuPoiListByType,
            GetBusGpsInfo:GetBusGpsInfo
        }
    }

    return InterFace;

})