﻿define(function(require) {

	var InterFace = function(AppInfo) {
		//返回Main的路由
		var Main = function(cb) {
			require([AppInfo.BaseUrl + "/modules/main/script/router.js"], function(router) {
				if (cb)
					cb(router(AppInfo));
			})
		}
		//供从个人中心调用app-info.js中配置的个人中心项目 测试用
		var OpenPhoneInfo = function() {
			Main(function(Router) {
				Router.OpenPhoneInfo();
			})
		}
		//读取航班看板航空公司数据
		var GetAirlineCompan = function(CB) {
			var url = AppInfo.CustomItems.Url.GetAviationCon;
			AppFrame.Http.Get(url, function(ret, err) {
				if (ret && ret.length > 0) {
					var AirlineCompan = [];
					var tmpArr = [], hash = {};
					for (var i = 0; i < ret.length; i++) {
						AirlineCompan.push(ret[i].airlnNM);
					}
					for (var j = 0; j < AirlineCompan.length; j++) {
						if (!hash[AirlineCompan[j]]) {
							hash[AirlineCompan[j]] = true;
							//存入hash表
							tmpArr.push(AirlineCompan[j]);
							//存入临时数组
						}
					}
					
				} else {
					AppFrame.Ext.Toast("数据访问出错");
				}
				if (CB) CB(tmpArr, err);
			});
		}

		return {
			Main : Main,
			GetAirlineCompan:GetAirlineCompan,
			OpenPhoneInfo : OpenPhoneInfo

		}
	}

	return InterFace;

})