/**
 * Created by tianling on 2017/1/10.
 */
//快照
var snapshoot = function() {
    var snapshootItems = [];
    var Lat = 0,
        Lng = 0;
    var getSnapshootItems = function() {
        return snapshootItems;
    }

    var getData = function(lat, lng, cb) {
        //AppFrame.Ext.ShowProgress("", "", "");
        InterFace.GetSnapshootItems(0, "", lat, lng, 50, function(ret, err) {
            // AppFrame.Ext.HideProgress();
            if (ret && ret.Result == 1) {
                if (ret.Data.length > 0) {
                    snapshootItems = ret.Data;
                    if (cb)
                        cb(null, ret.Data);
                } else {
                    AppFrame.Ext.Toast("暂无快照", "top");
                    cb();
                }

            } else {
                if (err) {
                    AppFrame.Ext.Toast(err.msg, "top");
                } else {
                    AppFrame.Ext.Toast("数据读取错误", "top");
                }
                cb();
            }
        })
    }
    var AddMarks = function(lat, lng) {
        if (Lat != lat || Lng != lng) {
            Lat = lat;
            Lng = lng;
        } else {
            return;
        }
        var screenWidth = api.screenWidth;
        var marks = [];
        clearMark();
        then(function(defer) {
            getData(lat, lng, defer);
        }).then(function(defer, ret) {
            if (ret && ret.length > 0) {
                for (var i in ret) {
                    var item = ret[i];
                    var markModel = bMap.mark.getMarkModel();
                    markModel.type = 'snapshoot';
                    markModel.id = item.P_ID;
                    markModel.lon = item.Lng;
                    markModel.lat = item.Lat;
                    markModel.icon = "fs://wgt/traffic/image/snapshoot/snapshoot.png";
                    markModel.activeIcon = "fs://wgt/traffic/image/snapshoot/snapshoot_active.png";
                    if (screenWidth < 720) {
                        markModel.icon = markModel.icon.replace('.png', '_s.png');
                        markModel.activeIcon = markModel.activeIcon.replace('.png', '_s.png');
                    }
                    marks.push(markModel);
                }
                bMap.mark.add(marks, function(ret) {
                    if (ret) {
                        if (ret.eventType == "click") {
                            for (var i in snapshootItems) {
                                if (snapshootItems[i].P_ID == ret.id) {
                                    bMap.layout.show(mapLayoutRouter.RouterModel.snapShoot.FrameName);
                                    api.sendEvent({
                                    	name : 'getSnapShoot',
                                    	extra : snapshootItems[i]
                                    });



                                    break;
                                }
                            }
                        }
                    }
                });
            }
        });

    }
    var removeMark = function(ids) {
        bMap.mark.remove('snapshoot', ids);
    };

    var clearMark = function() {
        bMap.mark.remove('snapshoot');
    };

    var openMarkInfoLayout = function() {
        var frameWidth = api.frameWidth;
        var size = frameWidth / 1.776 + 10 + 25;

        var frame = mapLayoutRouter.RouterModel.snapShoot;
        bMap.layout.open(frame.FrameName, frame.FrameUrl, size, "top", null, true, true);
    };

    return {
        getSnapshootItems: getSnapshootItems,
        AddMarks: AddMarks,
        removeMark: removeMark,
        clearMark: clearMark,
        openMarkInfoLayout: openMarkInfoLayout
    }
}();
