/**
 * Created by tianling on 2017/1/10.
 */
//交通事件
var trafficEvent = function() {
	var TrafficStateItems = [];
	//交通事件
	var getTrafficStateItems = function() {
		return TrafficStateItems;
	}
	//获取交通事件
	var getData = function() {
		AppFrame.Ext.ShowProgress("", "", "");
		InterFace.GetTafficState(function(ret, err) {
			AppFrame.Ext.HideProgress();
			if (ret && ret.Result == 1) {
				TrafficStateItems = ret.Data.TrafficStateItems;
				AddMarks();
			} else {
				AppFrame.Ext.Toast("数据读取错误", "top");
			}
		})
	}
	var AddMarks = function(trafficClassCode) {
		var screenWidth = api.screenWidth;
		var marks = [];
		if (TrafficStateItems.length == 0) {
			getData();
		} else {
			clearMark();

			for (var i in TrafficStateItems) {
				var item = TrafficStateItems[i];
				if (trafficClassCode) {
					if (trafficClassCode != item.EI_ClassCode)
						continue;
				}
				var markModel = bMap.mark.getMarkModel();
				markModel.type = 'traffic-event';
				markModel.id = item.EI_ID;
				markModel.lon = item.EI_Lng;
				markModel.lat = item.EI_Lat;
				switch (item.EI_ClassCode) {
					case "交通事故":
						markModel.icon = "fs://wgt/traffic/image/event/jtsg.png";
						markModel.activeIcon = "fs://wgt/traffic/image/event/jtsg_active.png";
						break;
					case "施工养护":
						markModel.icon = "fs://wgt/traffic/image/event/sgyf.png";
						markModel.activeIcon = "fs://wgt/traffic/image/event/sgyf_active.png";
						break;
					case "交通管制":
						markModel.icon = "fs://wgt/traffic/image/event/jtgz.png";
						markModel.activeIcon = "fs://wgt/traffic/image/event/jtgz_active.png";
						break;
					case "交通拥堵":
						markModel.icon = "fs://wgt/traffic/image/event/jtyd.png";
						markModel.activeIcon = "fs://wgt/traffic/image/event/jtyd_active.png";
						break;
					case "公交事件":
						markModel.icon = "fs://wgt/traffic/image/event/gjsj.png";
						markModel.activeIcon = "fs://wgt/traffic/image/event/gjsj_active.png";
						break;
					case "自然灾害":
						markModel.icon = "fs://wgt/traffic/image/event/zrzh.png";
						markModel.activeIcon = "fs://wgt/traffic/image/event/zrzh_active.png";
						break;
					case "安全提示":
						markModel.icon = "fs://wgt/traffic/image/event/aqts.png";
						markModel.activeIcon = "fs://wgt/traffic/image/event/aqts_active.png";
						break;
				}
				if (screenWidth < 720) {
					markModel.icon = markModel.icon.replace('.png', '_s.png');
					markModel.activeIcon = markModel.activeIcon.replace('.png', '_s.png');
				}
				marks.push(markModel);

			}

			bMap.mark.add(marks, function(ret) {
				if (ret) {
					if (ret.eventType == "click") {
						for (var i in TrafficStateItems) {
							if (TrafficStateItems[i].EI_ID == ret.id) {
								bMap.map.setCenter({
									coords : {
										lon : TrafficStateItems[i].EI_Lng,
										lat : TrafficStateItems[i].EI_Lat
									},
									animation : true
								});
								bMap.layout.show(mapLayoutRouter.RouterModel.trafficEvent.FrameName);
								api.sendEvent({
									name : 'getTrafficEvent',
									extra : TrafficStateItems[i]
								});
								break;
							}
						}
					}
				}
			});

		}

	}
	var openMarkInfoLayout = function() {
		var frame = mapLayoutRouter.RouterModel.trafficEvent;
		bMap.layout.open(frame.FrameName, frame.FrameUrl, 100, "top", null, true, true);
	};
	var removeMark = function(ids) {
		bMap.mark.remove('traffic-event', ids);
	};

	var clearMark = function() {
		bMap.mark.remove('traffic-event');
	};

	return {
		getTrafficStateItems : getTrafficStateItems,
		getData : getData,
		AddMarks : AddMarks,
		removeMark : removeMark,
		clearMark : clearMark,
		openMarkInfoLayout : openMarkInfoLayout
	}

}();
