define(["ext",'frame-data'] , function(){

	var Router=function(){
	    var WinUrl = api.wgtRootDir +"/modules/win-frame.html";//带头部导航的母版窗口
	    var NoHeaderWinUrl=api.wgtRootDir +"/modules/win-frame-noheader.html";//不带头部导航的母版窗口
	    var ApiBaseUrl="http://119.62.44.163:820/api";
        //var ApiBaseUrl="http://172.16.187.85:820/api";
	    var Url={
	        Login : ApiBaseUrl+"/Base/user/login",
	        Register : ApiBaseUrl + "/Base/user/Reg?type=json",//注册用户
	        GetSmsCode:ApiBaseUrl + "/Base/Sms/GetSmsCode?type=json",//获取短信验证码
	        VerifySmsCode:ApiBaseUrl + "/Base/Sms/verifySmsCode?type=json",//验证短信验证码
	        UploadHeaderPic : ApiBaseUrl + "/Base/user/UploadUserHead",//上传用户头像
	        UpdateUserInfo : ApiBaseUrl + "/Base/user/UpdateInfo?type=json",//更新用户信息
	        EditPwd:ApiBaseUrl + "/Base/user/EditPwd?type=json",//修改密码
            ReSetPwd:ApiBaseUrl + "/Base/user/ReSetPwd?type=json",//重置密码
	        CheckUserMobile: ApiBaseUrl + "/Base/user/CheckUserMobile" ,//检测电话号码是否存在{0：存在 1：不存在}
            GetAllSubscribeChannel:ApiBaseUrl + "/Base/Push/GetAllSubscribeChannel", //获取订阅全部频道
            SubscribeAll: ApiBaseUrl + "/Base/Push/SubscribeAll", //订阅全部频道
            GetUserSubscribe:ApiBaseUrl + "/Base/Push/GetUserSubscribe",//获取用户订阅的频道
            SetClientTag:ApiBaseUrl + "/Base/Push/SetClientTag",//设置用户push tag
            GetPushMsgInfo:ApiBaseUrl + "/Base/Push/GetPushMsgInfo",//获取订阅消息详情
            GetUserMsg:ApiBaseUrl + "/Base/Push/GetUserMsg",//获取用户订阅的消息列表
            GetUserSubscribeInfo:ApiBaseUrl + "/Base/Push/GetUserSubscribeInfo",//获取用户订阅某个频道的的详情
            DoSubscribe:ApiBaseUrl + "/Base/Push/AddClientTag",//订阅操作
            DoUnSubscribe:ApiBaseUrl + "/Base/Push/RemoveClientTag",//取消订阅操作
            SetIsNotification:ApiBaseUrl + "/Base/Push/SetIsNotification",//设置是否通知栏提醒
            SetIsRead:ApiBaseUrl + "/Base/Push/SetIsRead"//设置是否已读
	    }
	    
		var RouterModel = {
			Login: {
			    AppID:api.appId, //应用ID
			    WinName:'Login-Win', //Win的名称
			    WinUrl:api.wgtRootDir  + "/modules/user/index-con.html",  //Win的路径地址
				FrameName: 'Login', //Win中开启Frame的名称
				FrameUrl: api.wgtRootDir  + "/modules/user/login.html", //Win中开启Frame的路径地址
				BgColor: '#1E81D2', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
				Title: '用户登录', //窗口标题
				slidBackEnabled:false,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
				ShowProgress:true, //是否显示加载进度条
				Bounces:false, //Frame是否开启弹动效果
				ScaleEnabled:false, //Frame中的页面是否可以缩放
				Reload:false, //再次切换到此窗口时，是否重新加载Frame
                FrameAnimation: {
                    type: "none"
                }
			},
			Reg: {
			    AppID:api.appId, //应用ID
			    WinName:'Reg-Win', //Win的名称
			    WinUrl:WinUrl,
			    FrameName:'Reg',
			    FrameUrl:api.wgtRootDir  + "/modules/user/reg.html",  //Win的路径地址
				BgColor: '#1E81D2', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
				Title: '用户注册', //窗口标题
				slidBackEnabled:false,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
				ShowProgress:false, //是否显示加载进度条
				Bounces:false, //Frame是否开启弹动效果
				ScaleEnabled:false, //Frame中的页面是否可以缩放
				Reload:false //再次切换到此窗口时，是否重新加载Frame

			},
            ResetPwd:{
                AppID:api.appId, //应用ID
                WinName:'ResetPwd-Win', //Win的名称
                WinUrl:WinUrl,  //Win的路径地址
                FrameName: 'ResetPwd', //Win中开启Frame的名称
                FrameUrl: api.wgtRootDir  + "/modules/user/reset-pwd.html", //Win中开启Frame的路径地址
                BgColor: '#1E81D2', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '找回密码', //窗口标题
                slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:false, //是否显示加载进度条
                Bounces:false, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false //再次切换到此窗口时，是否重新加载Frame
            },
			Index: {
			    AppID:api.appId, //应用ID
			    WinName:'Index-Win', //Win的名称
			    WinUrl:api.wgtRootDir  + "/modules/user/index-con.html",  //Win的路径地址
				FrameName: 'Index', //Win中开启Frame的名称
				FrameUrl: api.wgtRootDir  + "/modules/user/index.html", //Win中开启Frame的路径地址
				BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
				Title: '用户中心', //窗口标题
				slidBackEnabled:false,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
				ShowProgress:true, //是否显示加载进度条
				Bounces:true, //Frame是否开启弹动效果
				ScaleEnabled:false, //Frame中的页面是否可以缩放
				Reload:false //再次切换到此窗口时，是否重新加载Frame
				
			},
			UserInfo:{
			    AppID:api.appId, //应用ID
			    WinName:'UserInfo-Win', //Win的名称
			    WinUrl:WinUrl,  //Win的路径地址
				FrameName: 'UserInfo', //Win中开启Frame的名称
				FrameUrl: api.wgtRootDir  + "/modules/user/user-info.html", //Win中开启Frame的路径地址
				BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
				Title: '个人信息', //窗口标题
				slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
				ShowProgress:false, //是否显示加载进度条
				Bounces:true, //Frame是否开启弹动效果
				ScaleEnabled:false, //Frame中的页面是否可以缩放
				Reload:false//再次切换到此窗口时，是否重新加载Frame
			},
			UserPwd:{
			    AppID:api.appId, //应用ID
			    WinName:'UserPwd-Win', //Win的名称
			    WinUrl:WinUrl,  //Win的路径地址
				FrameName: 'UserPwd', //Win中开启Frame的名称
				FrameUrl: api.wgtRootDir  + "/modules/user/user-pwd.html", //Win中开启Frame的路径地址
				BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
				Title: '修改登录密码', //窗口标题
				slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
				ShowProgress:false, //是否显示加载进度条
				Bounces:true, //Frame是否开启弹动效果
				ScaleEnabled:false, //Frame中的页面是否可以缩放
				Reload:false//再次切换到此窗口时，是否重新加载Frame
			},
            UserMsg:{
                AppID:api.appId, //应用ID
                WinName:'UserMsg-Win', //Win的名称
                WinUrl:WinUrl,  //Win的路径地址
                FrameName: 'UserMsg', //Win中开启Frame的名称
                FrameUrl: api.wgtRootDir  + "/modules/user/user-msg.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '我的消息', //窗口标题
                slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:false, //是否显示加载进度条
                Bounces:true, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false, //再次切换到此窗口时，是否重新加载Frame
                RightBtnHtml:"订阅"
            },
            UserMsgInfo:{
                AppID:api.appId, //应用ID
                WinName:'UserMsgInfo-Win', //Win的名称
                WinUrl:WinUrl,  //Win的路径地址
                FrameName: 'UserMsg-Info', //Win中开启Frame的名称
                FrameUrl: api.wgtRootDir  + "/modules/user/msg-info.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '详情', //窗口标题
                slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:false, //是否显示加载进度条
                Bounces:true, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false //再次切换到此窗口时，是否重新加载Frame

            },
            Subscibe:{
                AppID:api.appId, //应用ID
                WinName:'Subscibe-Win', //Win的名称
                WinUrl:WinUrl,  //Win的路径地址
                FrameName: 'Subscibe', //Win中开启Frame的名称
                FrameUrl: api.wgtRootDir  + "/modules/user/subscibe.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '消息订阅', //窗口标题
                slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:false, //是否显示加载进度条
                Bounces:true, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false //再次切换到此窗口时，是否重新加载Frame

            },
            SubscibeChildren:{
                AppID:api.appId, //应用ID
                WinName:'Subscibe-Children-Win', //Win的名称
                WinUrl:WinUrl,  //Win的路径地址
                FrameName: 'Subscibe-Children', //Win中开启Frame的名称
                FrameUrl: api.wgtRootDir  + "/modules/user/subscibe-children.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '消息订阅', //窗口标题
                slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:false, //是否显示加载进度条
                Bounces:true, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false //再次切换到此窗口时，是否重新加载Frame
            },
            SubscibeInfo:{
                AppID:api.appId, //应用ID
                WinName:'Subscibe-Info-Win', //Win的名称
                WinUrl:WinUrl,  //Win的路径地址
                FrameName: 'Subscibe-Info', //Win中开启Frame的名称
                FrameUrl: api.wgtRootDir  + "/modules/user/subscibe-info.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '消息订阅', //窗口标题
                slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:false, //是否显示加载进度条
                Bounces:true, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false //再次切换到此窗口时，是否重新加载Frame

            },
            OutSite:{
                AppID:api.appId, //应用ID
                WinName:'OutSite-Win', //Win的名称
                WinUrl:WinUrl,  //Win的路径地址
                FrameName: 'OutSite-Info', //Win中开启Frame的名称
                FrameUrl: "", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '详情', //窗口标题
                slidBackEnabled:true,  //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress:true, //是否显示加载进度条
                Bounces:false, //Frame是否开启弹动效果
                ScaleEnabled:false, //Frame中的页面是否可以缩放
                Reload:false //再次切换到此窗口时，是否重新加载Frame

            },
		}
		
		/**
		 * 开启登录窗口 用于子应用模块调用登录窗口
		 * @param {Object} CBWinName 登录成功后执行回调方法的Win的名称
		 * @param {Object} CBWinFrameName 登录成功后执行回调方法的Frame的名称
		 * @param {Object} CBMethod 登录成功后执行的回调方法
		 */
		var OpenLoginWin = function(CBWinName,CBWinFrameName,CBMethod) {
			RouterModel.Login.CBWinName=CBWinName;
			RouterModel.Login.CBWinFrameName=CBWinFrameName;
			RouterModel.Login.CBMethod=CBMethod;
			Ext.OpenWin(RouterModel.Login.WinName , RouterModel.Login.WinUrl , RouterModel.Login.slidBackEnabled, RouterModel.Login);
		} 
		
		var OpenRegxWin = function() {;
			Ext.OpenWinByModel(RouterModel.Reg);
		} 
		
		
		var OpenIndexWin = function() {;
			Ext.OpenWin(RouterModel.Index.WinName , RouterModel.Index.WinUrl , RouterModel.Index.slidBackEnabled, RouterModel.Index);
		} 
		
		var OpenUserInfoWin = function() {
		    RouterModel.UserInfo.CloseType=3;//采用自定义关闭事件
			Ext.OpenWinByModel(RouterModel.UserInfo);
		} 
		
		var OpenIndexFrame=function(){
			var hread=$api.byId("header");
            var hreadPos = $api.offset(hread);
			RouterModel.Index.Rect={
					x : hreadPos.l,
					y : hreadPos.h,
					// w: mainPos.w,
					h : api.winHeight-hreadPos.h
				}
			Ext.OpenFrameByModel(RouterModel.Index);
		}
		
		var OpenLoginFrame=function(){
			Ext.OpenFrameByModel(RouterModel.Login);
		}
		
		var OpenUerPwdWin=function(){
			Ext.OpenWinByModel(RouterModel.UserPwd);
		}

		var OpenUserMsgWin=function () {
			Ext.OpenWinByModel(RouterModel.UserMsg);
        }
        var OpenReSetPwdWin=function () {
            Ext.OpenWinByModel(RouterModel.ResetPwd);
        }

        var OpenSubscibeWin = function() {
            Ext.OpenWinByModel(RouterModel.Subscibe);
        }

        var OpenSubscibeChildrenWin = function(title,ChildrenItems) {
            RouterModel.SubscibeChildren.Title=title;
            RouterModel.SubscibeChildren.ChildrenItems=ChildrenItems;
            Ext.OpenWinByModel(RouterModel.SubscibeChildren);
        }

        var OpenSubscibeInfoWin = function(title,dataItem) {
            RouterModel.SubscibeInfo.Title=title;
            RouterModel.SubscibeInfo.ItemData=dataItem;
            Ext.OpenWinByModel(RouterModel.SubscibeInfo);
        }

        var OpenOutSiteWin=function (Url) {
            RouterModel.OutSite.FrameUrl=Url;
            Ext.OpenWinByModel(RouterModel.OutSite);
        }

        var OpenUserMsgInfoWin=function (DataModel) {
            RouterModel.UserMsgInfo.DataModel=DataModel;
            Ext.OpenWinByModel(RouterModel.UserMsgInfo);
        }




        return {
			Url:Url,
			RouterModel: RouterModel,
			OpenLoginWin:OpenLoginWin,
			OpenRegxWin:OpenRegxWin,
			OpenLoginFrame:OpenLoginFrame,
			OpenIndexWin:OpenIndexWin,
			OpenIndexFrame:OpenIndexFrame,
			OpenUserInfoWin:OpenUserInfoWin,
			OpenUerPwdWin:OpenUerPwdWin,
            OpenUserMsgWin:OpenUserMsgWin,
            OpenReSetPwdWin:OpenReSetPwdWin, //重置密码
			OpenSubscibeWin:OpenSubscibeWin, //获取频道分类
            OpenSubscibeChildrenWin:OpenSubscibeChildrenWin, //获取二级栏目
            OpenSubscibeInfoWin:OpenSubscibeInfoWin, //用户关注的频道详情
            OpenOutSiteWin:OpenOutSiteWin , //开启外部页面
            OpenUserMsgInfoWin:OpenUserMsgInfoWin
		}
	}
	return Router;

})