﻿
define(function(require) {

    var InterFace = function(AppInfo) {
        //返回Main的路由
        var Main = function(cb) {
            require([AppInfo.BaseUrl + "/modules/main/script/router.js"], function(router) {
                if (cb) cb(router(AppInfo));
            })
        };
        var URL = 'http://119.62.44.163:820/api/BaiduJudge/v1';
        //打开出行统计界面
        var OpenAMainConWin = function() {
            Main(function(Router) {
                Router.OpenAMainConWin();
            })
        };
        //获取百度研判平均时速
        var GetRoadBoard = function(model, CB) {
            var url = AppInfo.CustomItems.Url.GetRoadBoard;
            var PostData = {
                IsHighRoad: model.IsHighRoad,
                CityCode: model.CityCode,
                BeginTime: model.BeginTime = model.BeginTime == '' ? undefined : model.BeginTime,
                EndTime: model.EndTime = model.EndTime == '' ? undefined : model.EndTime
            };
            AppFrame.Http.Post(URL + url, PostData, function(ret, err) {
                if (CB) CB(ret, err);
            })
        };
        //获取百度研判行政区排行
        var GetCityAdministrative = function(model, CB) {
            var url = AppInfo.CustomItems.Url.GetCityAdministrative;
            var PostData = {
                IsHighRoad: model.IsHighRoad,
                CityCode: model.CityCode,
                BeginTime: model.BeginTime = model.BeginTime == '' ? undefined : model.BeginTime,
                EndTime: model.EndTime = model.EndTime == '' ? undefined : model.EndTime
            };
            AppFrame.Http.Post(URL + url, PostData, function(ret, err) {
                if (CB) CB(ret, err);
            })
        };
        //获取百度研判区域排行
        var GetCityBusiness = function(model, CB) {
            var url = AppInfo.CustomItems.Url.GetCityBusiness;
            var PostData = {
                IsHighRoad: model.IsHighRoad,
                CityCode: model.CityCode,
                BeginTime: model.BeginTime = model.BeginTime == '' ? undefined : model.BeginTime,
                EndTime: model.EndTime = model.EndTime == '' ? undefined : model.EndTime
            };
            AppFrame.Http.Post(URL + url, PostData, function(ret, err) {
                if (CB) CB(ret, err);
            })
        };
        //获取百度研判道路拥堵路段
        var GetRank = function(model, CB) {
            var url = AppInfo.CustomItems.Url.GetRank;
            var PostData = {
                IsHighRoad: model.IsHighRoad,
                CityCode: model.CityCode,
                BeginTime: model.BeginTime = model.BeginTime == '' ? undefined : model.BeginTime,
                EndTime: model.EndTime = model.EndTime == '' ? undefined : model.EndTime
            };
            AppFrame.Http.Post(URL + url, PostData, function(ret, err) {
                if (CB) CB(ret, err);
            })
        };
        //获取百度研判道路拥堵路段
        var GetCongestionCurve = function(model, CB) {
            var url = AppInfo.CustomItems.Url.GetCongestionCurve;
            var PostData = {
                IsHighRoad: model.IsHighRoad,
                CityCode: model.CityCode,
                BeginTime: model.BeginTime = model.BeginTime == '' ? undefined : model.BeginTime,
                EndTime: model.EndTime = model.EndTime == '' ? undefined : model.EndTime
            };
            AppFrame.Http.Post(URL + url, PostData, function(ret, err) {
                // console.log("url:" + URL + url + "---post:" + JSON.stringify(PostData)+'---ret：---err'+JSON.stringify(err));
                if (CB) CB(ret, err);
            })
        };
        return {
            Main: Main,
            OpenAMainConWin: OpenAMainConWin,
            GetRoadBoard: GetRoadBoard,
            GetCityAdministrative: GetCityAdministrative,
            GetCityBusiness: GetCityBusiness,
            GetRank: GetRank,
            GetCongestionCurve:GetCongestionCurve
        }
    }

    return InterFace;

})
