﻿define(function(require) {

    var InterFace = function(AppInfo) {
        //返回transit的路由
       var transit = function(cb) {
            require([AppInfo.BaseUrl + "/modules/transit/script/router.js"], function(router) {
                if (cb) cb(router(AppInfo));
            })
        }



        /**
         * //获取起点城市列表
         */
       var getStartCity = function (CB){    
           var url = AppInfo.CustomItems.Url.StartCityList;        
           //console.log('url:'+url);
           AppFrame.Http.Get(url,  function(ret, err) {           
            	console.log('ret:'+JSON.stringify(ret));
            	if(CB) CB(ret, err);
           })
        };

		 //获取终点城市列表（在选择了目的地后开始查询）
	    var getEndCityStation = function (cityName,CB){	       
	        var url = AppInfo.CustomItems.Url.EndCityList;        	       	        
	        AppFrame.Http.Get(url+"?origin="+cityName,  function(ret, err) {
	            if (CB) CB(ret, err);	            
            });
        }
        
        //获取余票信息
        var GetTickInfo = function(data,CB){
        	var url = AppInfo.CustomItems.Url.ShiftInfo;  
        	AppFrame.Http.Get(url+"?origin="+data.origin+"&site="+data.site+"&date="+data.date,  function(ret, err) {
        		if(CB) CB(ret,err);
        	})
        }


        return {
            transit: transit,
            getStartCity: getStartCity,
            getEndCityStation: getEndCityStation,
            GetTickInfo:GetTickInfo

        }
    }

    return InterFace;

})