define(["ext", "frame-data"], function() {

    var Router = function(AppInfo) {
        var WinUrl = AppInfo.RootUrl + "/modules/win-frame.html"; //带头部导航的母版窗口
        var NoHeaderWinUrl = AppInfo.RootUrl + "/modules/win-frame-noheader.html"; //不带头部导航的母版窗口
        var ApiBaseUrl = FrameData.ApiBaseUrl;


        var RouterModel = {
            aviation: {
                AppID: AppInfo.AppID, //应用ID
                WinName: 'aviation-win', //Win的名称
                WinUrl: AppInfo.BaseUrl + "/index.html", //Win的路径地址
                FrameName: 'aviation', //Win中开启Frame的名称
                FrameUrl: AppInfo.BaseUrl + "/modules/main/aviation.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '航空看板', //窗口标题
                slidBackEnabled: false, //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress: true, //是否显示加载进度条
                Bounces: true, //Frame是否开启弹动效果
                ScaleEnabled: false, //Frame中的页面是否可以缩放
                Reload: false //再次切换到此窗口时，是否重新加载Frame
            }
        }
        var OpenAviationWin = function() {
            //RouterModel.Login.RightBtnHtml="<i class='mui-icon mui-icon-compose'></i>编辑";
            Ext.OpenWin(RouterModel.aviation.WinName, RouterModel.aviation.WinUrl, RouterModel.aviation.slidBackEnabled, RouterModel.aviation);
        }
        var OpenAviationFrame = function(data) {
            Ext.OpenFrame(RouterModel.aviation.FrameName, RouterModel.aviation.FrameUrl, null, RouterModel.aviation.BgColor, false, true, false, false);
        }
        return {

            RouterModel: RouterModel,
            OpenAviationWin: OpenAviationWin,
            OpenAviationFrame: OpenAviationFrame
        }
    }
    return Router;

})