﻿define(function(require) {

	var InterFace = function(AppInfo) {
		//返回Main的路由
		var Main = function(cb) {
			require([AppInfo.BaseUrl + "/modules/main/script/router.js"], function(router) {
				if (cb)
					cb(router(AppInfo));
			})
		}
		//跳转详情页
		var ToDetailPage = function(data) {
			Main(function(Router) {
				if (data.labelcode == "002") {
					GetData(data.uid, function(ret, err) {
						Router.OpenServiceAreaInfo(ret.Data);
					})
				}
				if (data.labelcode == "003") {
					var obj = {
						PID : data.uid,
						P_Name : data.name
					}
					Router.OpenChargeQueryDetailInfo(obj);
				}
			})
		}
		//供从个人中心调用app-info.js中配置的个人中心项目 测试用
		var OpenPhoneInfo = function() {
			Main(function(Router) {
				Router.OpenPhoneInfo();
			})
		}
		//获取数据
		function GetData(PID, CB) {
			//接口地址
			var url = AppInfo.CustomItems.Url.GetHighWayServiceAreaDetail + "?PID=" + PID;
			//获取数据
			AppFrame.Http.Get(url, function(ret, err) {
				if (CB)
					CB(ret, err);
			})
		}

		return {
			Main : Main,
			OpenPhoneInfo : OpenPhoneInfo,
			GetData : GetData,
			ToDetailPage : ToDetailPage

		}
	}

	return InterFace;

})