define(["ext", "frame-data"], function() {

    var Router = function(AppInfo) {
        var WinUrl = AppInfo.RootUrl + "/modules/win-frame.html"; //带头部导航的母版窗口
        var NoHeaderWinUrl = AppInfo.RootUrl + "/modules/win-frame-noheader.html"; //不带头部导航的母版窗口
        var ApiBaseUrl = FrameData.ApiBaseUrl;


        var RouterModel = {
            metro: {
                AppID: AppInfo.AppID, //应用ID
                WinName: 'metro-win', //Win的名称
                WinUrl: AppInfo.BaseUrl + "/index.html", //Win的路径地址
                FrameName: 'metro', //Win中开启Frame的名称
                FrameUrl: AppInfo.BaseUrl + "/modules/main/metro-list.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '地铁服务', //窗口标题
                slidBackEnabled: false, //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress: false, //是否显示加载进度条
                Bounces: false, //Frame是否开启弹动效果
                ScaleEnabled: false, //Frame中的页面是否可以缩放
                Reload: false //再次切换到此窗口时，是否重新加载Frame
            },
           metroDesc: {
                AppID: AppInfo.AppID, //应用ID
                WinName: 'metroDesc-win', //Win的名称
                WinUrl: AppInfo.BaseUrl + "/modules/main/metro-con.html", //Win的路径地址
                FrameName: 'metroDesc', //Win中开启Frame的名称
                FrameUrl: AppInfo.BaseUrl + "/modules/main/metro-desc.html", //Win中开启Frame的路径地址
                BgColor: '#efeff4', //Frame的背景色 支持图片和颜色，格式为#fff、#ffffff、rgba(r,g,b,a)等，图片路径支持fs://、widget://等 APICloud 自定义文件路径协议，同时支持相对路径
                Title: '地铁服务', //窗口标题
                slidBackEnabled: false, //是否支持滑动返回。iOS7.0及以上系统中，在新打开的页面中向右滑动，可以返回到上一个页面，该字段只 iOS 有效
                ShowProgress: false, //是否显示加载进度条
                Bounces: false, //Frame是否开启弹动效果
                ScaleEnabled: false, //Frame中的页面是否可以缩放
                Reload: false //再次切换到此窗口时，是否重新加载Frame
            }
        }
        var OpenMetroFrame = function() {
            
            Ext.OpenFrame(RouterModel.metro.FrameName, RouterModel.metro.FrameUrl, null, RouterModel.metro.BgColor, false, false, false, false);
        }
//       var OpenNearbyMetroDescWin = function(NearMetro) {
//          RouterModel.nearbymetro.NearMetro = NearMetro;
//          Ext.OpenWin(RouterModel.nearbymetro.WinName, RouterModel.nearbymetro.WinUrl, RouterModel.nearbymetro.slidBackEnabled, RouterModel.nearbymetro);
//      }
        var OpenMetroDescWin = function(MetroArea) {
            RouterModel.metroDesc.Title = MetroArea;
            Ext.OpenWin(RouterModel.metroDesc.WinName, RouterModel.metroDesc.WinUrl, RouterModel.metroDesc.slidBackEnabled, RouterModel.metroDesc);
        }
        var OpenMetroDescFrame = function() {
            Ext.OpenFrame(RouterModel.metroDesc.FrameName, RouterModel.metroDesc.FrameUrl, null, RouterModel.metroDesc.BgColor, false, false, false, false);
        }
        return {

            RouterModel: RouterModel,
            OpenMetroFrame: OpenMetroFrame,
//          OpenNearbyMetroDescWin: OpenNearbyMetroDescWin,
            OpenMetroDescWin: OpenMetroDescWin,
            OpenMetroDescFrame: OpenMetroDescFrame
        }
    }
    return Router;

})