/**
 * Created by tianling on 2017/1/10.
 */
var weather = function () {
    var PageTitleHtml = "";
    var curWeatherType = "";
    var getPageTitleHtml = function () {

        if (PageTitleHtml == "") {
            var view = Dot.template($("#weatherTitleTmpl").text());
            PageTitleHtml = view();
        }
        return PageTitleHtml;

    }

    var getCurWeatherType=function(){
        return curWeatherType;
    }

    var city = function () {
        var CityWeatherItems = [];
        var markType = "weather-city";

        var getWeather = function () {
            curWeatherType=markType;
            bMap.mapControlBtn.hide("MapCenterMarkBtn");
            bMap.mark.clear();
            bMap.layout.UnShow();
            $(".btnGroup").find(".active").removeClass("active");
            $(".btnGroup").find(".item").eq(0).addClass("active");
            PageTitleHtml = $(".btnGroup")[0].outerHTML;
            $("#h_right").html("");
            bMap.map.setZoomLevel({
                level: 7
            });
            bMap.map.getZoomLevel(function(ret) {
                AddMarks(ret.level);
            });
            setTimeout(function () {

            },0);


        }

        var getData = function (MapZoom) {
            AppFrame.Ext.ShowProgress("", "", "");
            InterFace.GetYnWeather(function (ret, err) {
                AppFrame.Ext.HideProgress();
                if (ret && ret.Result == 1) {
                    CityWeatherItems = ret.Data;
                    AddMarks(MapZoom);
                } else {
                    AppFrame.Ext.Toast("数据读取错误", "top");
                }
            })
        }

        var AddMarks = function (MapZoom) {
            curWeatherType=markType;
            var screenWidth = api.screenWidth;
            var marks = [];
            if (CityWeatherItems.length == 0) {
                getData(MapZoom);
            } else {
                clearMark();
                for (var i in CityWeatherItems) {
                    var item = CityWeatherItems[i];
                    if (item.BasicInfo.MapZoom <= MapZoom) {
                        var markModel = bMap.mark.getMarkModel();
                        markModel.type = markType;
                        markModel.id = item.BasicInfo.id;
                        markModel.lon = item.BasicInfo.lon;
                        markModel.lat = item.BasicInfo.lat;
                        markModel.icon = "fs://wgt/traffic/image/weather/" + item.Now.cond.code + ".png";
                        markModel.activeIcon = "fs://wgt/traffic/image/weather/" + item.Now.cond.code + ".active.png";
                        if (screenWidth < 720) {
                            markModel.icon = markModel.icon.replace('.png', '-s.png');
                            markModel.activeIcon = markModel.activeIcon.replace('.active.png', '-s.active.png');
                        }
                        marks.push(markModel);
                    }

                }


                bMap.mark.add(marks, function (ret) {
                    if (ret) {
                        if (ret.eventType == "click") {
                            for (var i in CityWeatherItems) {
                                if (CityWeatherItems[i].BasicInfo.id == ret.id) {
                                    bMap.layout.show(mapLayoutRouter.RouterModel.weather.FrameName);
                                    api.sendEvent({
                                        name: 'getCityWeather',
                                        extra: CityWeatherItems[i]
                                    });
                                    break;
                                }
                            }
                        }
                    }
                });
            }


        }

        var removeMark = function (ids) {
            bMap.mark.remove(markType, ids);
        };
        var clearMark = function () {
            bMap.mark.remove(markType);
        };
        var openMarkInfoLayout = function () {
            var frameWidth = api.frameWidth;
            var frame = mapLayoutRouter.RouterModel.weather;
            bMap.layout.open(frame.FrameName, frame.FrameUrl, 120, "top", null, true, true);
        };

        return {
            getWeather: getWeather,
            AddMarks: AddMarks,
            removeMark: removeMark,
            clearMark: clearMark,
            openMarkInfoLayout: openMarkInfoLayout
        }


    }();

    var highWay = function () {
        var HighWayWeatherItems = [];
        var markType = "weather-highway";
        var roadCode = "";
        var Lat=0,Lng=0;
        var getCurSelectRoadCode=function () {
            return roadCode;
        }

        var setCurSelectRoadCode=function (value) {
            roadCode=value;
        }
        var getWeather = function () {
            curWeatherType=markType;
            bMap.mark.clear();

            bMap.layout.UnShow();
            $(".btnGroup").find(".active").removeClass("active");
            $(".btnGroup").find(".item").eq(1).addClass("active");
            PageTitleHtml = $(".btnGroup")[0].outerHTML;
            $("#h_right").html("<i class='iconfont icon-shaixuan'></i>");
            bMap.map.setZoomLevel({
                level: 12
            });
            if(roadCode==""){
                bMap.getLocation({},function (ret) {
                    if(ret){
                        if(bMap.mapControlBtn.isHasBtn("MapCenterMarkBtn")){
                            bMap.mapControlBtn.show("MapCenterMarkBtn");
                        }else{
                            bMap.mapControlBtn.addMapCenterBtn();
                        }
                        bMap.map.setCenter({
                            coords : {
                                lon : ret.lon,
                                lat : ret.lat
                            },
                            animation : true
                        });
                    }
                });
            }else{
                AddMarks(roadCode);
            }


        }

        var getData = function (roadCode,lat,lng ,cb) {
            if(roadCode!=""){
                AppFrame.Ext.ShowProgress("", "", "");
                lat="";
                lng="";
            }

            InterFace.GetHighWayWeather(roadCode ,lat,lng,20, function (data,err) {
                console.log("111" + JSON.stringify(data));
                if(roadCode!=""){
                    AppFrame.Ext.HideProgress();
                }
                if (data && data.length>0) {
                    if(cb)cb(null,data);
                } else {
                    console.log(JSON.stringify(err));
                    if(err){
                        AppFrame.Ext.Toast(err.msg, "top");
                    }else{
                        AppFrame.Ext.Toast("暂无数据", "top");
                    }
                    cb();
                }
            })
        }

        var AddMarks = function (_roadCode , lat,lng) {
            curWeatherType=markType;
            roadCode=_roadCode;
            if(roadCode==""){
                if(Lat==lat && Lng==lng){
                    return;
                }else{
                    Lat=lat;
                    Lng=lng;
                }
            }
            var screenWidth = api.screenWidth;
            var marks = [];
            clearMark();

            then(function (defer) {
                getData(_roadCode , lat ,lng ,defer);
            }).then(function (defer ,HighWayWeatherItems ) {
                for (var i in HighWayWeatherItems) {
                    var item = HighWayWeatherItems[i];

                    var markModel = bMap.mark.getMarkModel();
                    markModel.type = markType;
                    markModel.id = item.OBJECTID;
                    markModel.lon = item.Lng;
                    markModel.lat = item.Lat;
                    markModel.icon = "fs://wgt/traffic/image/weather/" + item.FORE_Day1.STATU_PIC.replace(".png","") + ".png";
                    markModel.activeIcon = "fs://wgt/traffic/image/weather/" + item.FORE_Day1.STATU_PIC.replace(".png","") + ".active.png";
                    if (screenWidth < 720) {
                        markModel.icon = markModel.icon.replace('.png', '-s.png');
                        markModel.activeIcon = markModel.activeIcon.replace('.active.png', '-s.active.png');
                    }
                    marks.push(markModel);
                    if(marks.length>0){
                        if(_roadCode!=""){

                            bMap.map.setCenter({
                                coords: {
                                    lon: marks[0].lon,
                                    lat: marks[0].lat
                                },
                                animation: true
                            });
                        }
                        bMap.mark.add(marks, function (ret) {
                            if (ret) {
                                if (ret.eventType == "click") {

                                    for (var i in HighWayWeatherItems) {
                                        if (HighWayWeatherItems[i].OBJECTID == ret.id) {

                                            console.log(mapLayoutRouter.RouterModel.weather.FrameName);
                                            bMap.layout.show(mapLayoutRouter.RouterModel.weather.FrameName);
                                            AppFrame.Ext.ExecScript("", mapLayoutRouter.RouterModel.weather.FrameName, "getHighWayWeather('"+JSON.stringify( HighWayWeatherItems[i])+"')");
                                            break;
                                        }
                                    }
                                }



                            }
                        });
                    }
                }
            })

        }

        var clearMark = function () {
            bMap.mark.remove(markType);
        };

        var removeMark = function (ids) {
            bMap.mark.remove(markType, ids);
        };

        var openMarkInfoLayout = function () {
            var frameWidth = api.frameWidth;
            var frame = mapLayoutRouter.RouterModel.weather;
            bMap.layout.open(frame.FrameName, frame.FrameUrl, 120, "top", null, true, true);
        };

        return {
            getCurSelectRoadCode:getCurSelectRoadCode,
            setCurSelectRoadCode:setCurSelectRoadCode,
            getWeather: getWeather,
            AddMarks: AddMarks,
            removeMark: removeMark,
            clearMark: clearMark,
            openMarkInfoLayout: openMarkInfoLayout


        }
    }();


    return {
        getCurWeatherType:getCurWeatherType,
        getPageTitleHtml: getPageTitleHtml,
        city: city,
        highWay: highWay
    }
}();