﻿define(function(require) {

	var InterFace = function(AppInfo) {
		//返回Main的路由
		var Thenjs;
		var transit = function(cb) {

			require([AppInfo.BaseUrl + "/modules/transit/script/router.js"], function(router) {

				if (cb)
					cb(router(AppInfo));
			})
		}
		//搜索列车时刻表
		function DoSearch(from, to, FromCode, ToCode, date, CB) {
			var ReturnData = {};
			ReturnData.from = from;
			ReturnData.to = to;
			ReturnData.date = date;
			ReturnData.fromcode = FromCode;
			ReturnData.tocode = ToCode;
			ReturnData.TrainList = [];
			var url = AppInfo.CustomItems.Url.TrainSearch;
			var PostData = {
				From : FromCode,
				To : ToCode,
				Date : date
			};

			AppFrame.Http.Post(url, PostData, function(ret, err) {

				
				if (ret && ret.Result == 1) {
				console.log(JSON.stringify(ret));
					if(ret.Data.TrainList == null){
						Ext.HideProgress();
						Ext.Toast("抱歉,没有找到符合条件的火车票","bottom");   
						return;
					}
					if (ret.Data && ret.Data.TrainList.length > 0) {

						var Data = ret.Data;
						console.log("原始数据 = " + JSON.stringify(Data));
						Thenjs = require('then');
						
						Thenjs.eachSeries(Data.TrainList,function (cont, value, index, array){
							var Train =value.queryLeftNewDTO
								Train.lishi = Train.lishi.replace(":", "小时") + "分";
								var diffDay = Number(Train.day_difference) + 1;
								if (diffDay == 2) {
									Train.arrive_time = Train.start_time + "-" + "次日 " + Train.arrive_time;
								} else if (diffDay == 1) {
									Train.arrive_time = Train.start_time + "-" + "当日 " + Train.arrive_time;
								} else {
									Train.arrive_time = Train.start_time + "-" + "第" + diffDay + "天 " + Train.arrive_time;
								}
								var seatInfos = GetSeatInfos(Train);
								Train.seatInfos = seatInfos;
								
								if(Train.controlled_train_message!='列车停运'){
									ReturnData.TrainList.push(Train);
								}

									cont(null,ReturnData);
//								})
							
						}).then(function (cont, value) {


 					 		if (CB)
								CB(ReturnData);
						})

	
							
					}	
					

				}

			
		})
	}

		function GetSeatInfos(TrainInfo) {

			var seatInfos = [];

//			QueryTicketPrice(TrainInfo.train_no, TrainInfo.from_station_no, TrainInfo.to_station_no, date, TrainInfo.seat_types, function(ret, err) {
//				console.log("QueryTicketPrice = " + JSON.stringify(ret));

				var str = TrainInfo.station_train_code.substring(0, 1);
				console.log("str = " + str);
//				alert(typeof str);  
				if (str == 'G' || str == 'D') {
 					if (str == 'G') {
					console.log("str = G ");
						seatInfos.push({
							seatType : 'A9',
							seat : "商务座",
							seatPrice : "--",
							remainNum : TrainInfo.swz_num
						});
					}
					seatInfos.push({
						seatType : 'M',
						seat : "一等坐",
						seatPrice : "--",
						remainNum : TrainInfo.zy_num
					});
					seatInfos.push({
						seatType : 'O',
						seat : "二等座",
						seatPrice : "--",
						remainNum : TrainInfo.ze_num
					});
					seatInfos.push({
						seatType : 'WZ',
						seat : "无座",
						seatPrice : "--",
						remainNum : TrainInfo.wz_num
					});
					
				} else {
				seatInfos.push({
						seatType : 'A1',
						seat : "硬座",
						seatPrice : "--",
						remainNum : TrainInfo.yz_num
					});
					seatInfos.push({
						seatType : 'WZ',
						seat : "无座",
						seatPrice :"--",
						remainNum : TrainInfo.wz_num
					});
					seatInfos.push({
						seatType : 'A4',
						seat : "软卧",
						seatPrice : "--",
						remainNum : TrainInfo.rw_num
					});
					seatInfos.push({
						seatType : 'A3',
						seat : "硬卧",
						seatPrice : "--",
						remainNum : TrainInfo.yw_num
					});
					
				}
				console.log("seatInfos = " + JSON.stringify(seatInfos));
				
				return  seatInfos;
//				if (CB)
//					CB(seatInfos);

//		})
		}
		
	

		//获取列车途经站点
		function GetTrainLine(from, to, fromCode, toCode, train, trainNo, date, CB) {
			var ReturnData = {};
			ReturnData.from = from;
			ReturnData.to = to;
			ReturnData.date = date;
			ReturnData.passSiteItems = [];
			var url = AppInfo.CustomItems.Url.GetTrainLine;
			var PostData = {
				from_station_code : fromCode,
				to_station_code : toCode,
				train_no : trainNo,
				date : date,
				dubeg : 1
			};
			console.log("PostData = " + JSON.stringify(PostData));
			AppFrame.Http.Post(url, PostData, function(ret, err) {
				console.log("ret = " + JSON.stringify(ret));
				if (ret.Result == 1 && ret.Data) {
					for (var i in ret.Data.data) {
						var item = ret.Data.data[i];
						ReturnData.passSiteItems.push(item);
					}
				}
				if (CB)
					CB(ReturnData);
			})
		}

		function QueryTicketPrice(train_no, from_station_no, to_station_no, date, seat_types, CB) {
			var PostData = {
				train_no : train_no,
				from_station_no : from_station_no,
				end_station_no : to_station_no,
				date : date,
				seat_types : seat_types
			}
			var url = AppInfo.CustomItems.Url.QueryTicketPrice;
			AppFrame.Http.Post(url, PostData, function(ret, err) {
				if (CB)
					CB(ret);
			})
		}

		return {
			transit : transit,
			DoSearch : DoSearch,
			GetTrainLine : GetTrainLine,
			QueryTicketPrice : QueryTicketPrice
		}
	}

	return InterFace;

})